﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Runtime.InteropServices;

using System.Security.Principal;

namespace WindowsFormsClient
{
    /// <summary>
    /// Define RPC_C_AUTHN_LEVEL_ constants
    /// </summary>
    public enum RpcAuthnLevel
    {
        Default = 0,
        None,
        Connect,
        Call,
        Pkt,
        PktIntegrity,
        PktPrivacy
    }

    /// <summary>
    /// Define RPC_C_IMP_LEVEL_ constants
    /// </summary>
    public enum RpcImpLevel
    {
        Default = 0,
        Anonymous,
        Identify,
        Impersonate,
        Delegate
    }

    /// <summary>
    /// Define EOAC_ constants
    /// </summary>
    public enum EoAuthnCap
    {
        None = 0x0000,
        MutualAuth = 0x0001,
        StaticCloaking = 0x0020,
        DynamicCloaking = 0x0040,
        AnyAuthority = 0x0080,
        MakeFullSIC = 0x0100,
        Default = 0x0800,
        SecureRefs = 0x0002,
        AccessControl = 0x0004,
        AppID = 0x0008,
        Dynamic = 0x0010,
        RequireFullSIC = 0x0200,
        AutoImpersonate = 0x0400,
        NoCustomMarshal = 0x2000,
        DisableAAA = 0x1000
    }

    static class Program
    {
        // Create the call with PreserveSig:=FALSE so the COM InterOp
        // layer will perform the error checking and throw an 
        // exception instead of returning an HRESULT.
        //
        [DllImport("Ole32.dll",
               ExactSpelling = true,
               EntryPoint = "CoInitializeSecurity",
               CallingConvention = CallingConvention.StdCall,
               SetLastError = false,
               PreserveSig = false)]

        private static extern void CoInitializeSecurity(
            IntPtr pVoid,
            int cAuthSvc,
            IntPtr asAuthSvc,
            IntPtr pReserved1,
            uint dwAuthnLevel,
            uint dwImpLevel,
            IntPtr pAuthList,
            uint dwCapabilities,
            IntPtr pReserved3);

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // Usage
            // Initialize COM security for the process specifying impersonate for the outgoing calls

            CoInitializeSecurity(IntPtr.Zero,
            -1,
            IntPtr.Zero,
            IntPtr.Zero,
            (uint)RpcAuthnLevel.None,
            (uint)RpcImpLevel.Identify,
            IntPtr.Zero,
            (uint)EoAuthnCap.None,
            IntPtr.Zero);

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }
    }
}
